#include "Fivewin.ch"
#include "fileio.ch"
#include "Hbclass.ch"

STATIC Doc, Http

CLASS TFPOPULAR

   DATA SenhaFar         INIT ""                  //Senha da Farmcia
   DATA SenhaVen         INIT ""                  //Senha do Vendedor
   DATA UsuarioFar       INIT ""                  //Usario da Farmcia
   DATA UsuarioVen       INIT ""                  //Usario do Vendedor
   DATA Data_Receita     INIT CTOD("  /  /    ")  //Data da Receita
   DATA Cnpj             INIT ""                  //CNPJ da Farmcia
   DATA nSolicitacao     INIT ""                  //Nmero da Solicitao gerado pela Aplicao
   DATA nAutorizacao     INIT ""                  //Nmero da Autorizao gerado pelo Farmcia Popular
   DATA Cpf              INIT ""                  //CPF do Paciente
   DATA Nome             INIT ""                  //Nome do Paciente retornado pelo Farmcia Popular
   DATA Crm              INIT ""                  //CRM do Prescritor da Receita
   DATA UF               INIT ""                  //Estado do CRM do Prescritor
   DATA lAmbiente        INIT .F.                 //Tipo de Ambiente .T.=Produo e .F.=Homologao
   DATA lConectado       INIT .T.                 //Flag que indica se est conectado  
   DATA CupomFiscal      INIT ""                  //Nmero do Cupom Fiscal gerado pela Aplicao
   DATA Vinculado        INIT ""                  //Cupom Vinculado retornado pelo Farmcia Popular
   DATA Status           INIT ""                  //Status da Transao retornado pelo Farmcia Popular
   DATA CodRetorno       INIT ""                  //Cdigo de Retorno da Transao retornado pelo Farmcia Popular
   DATA Mensagem         INIT ""                  //Mensagem retornada pelo Farmcia Popular
   DATA aProdutos        INIT {}                  //Array dos Produtos gerado pela Aplicao
   DATA Dna              INIT ""                  //DNA da Estao
   
   METHOD New(cCnpj,Tipo_Ambiente) CONSTRUCTOR
   METHOD TFPSolicitacao()                         //Solicitao de Pr-Autorizao
   METHOD TFPConfirmacao()                         //Confirmao da Pr-Autorizao
   METHOD TFPRecebimento()                         //Confirmao do Recebimento da Pr-Autorizao
   METHOD TFPEstorno()                             //Estorno dos Produtos Pr-Autorizados
   METHOD TFPGeraDna()                             //Gerao do DNA da Estao
   METHOD TFPConecta()                             //Cria o WebService e o Documento do Xml
   METHOD ZeraVariaveis()                          //Limpa as Variaveis
   METHOD End()                                    //Fecha o Objeto

ENDCLASS

METHOD New(cCnpj,Tipo_Ambiente) CLASS TFPOPULAR

   ::ZeraVariaveis()
   ::Cnpj      := cCnpj
   ::lAmbiente := Tipo_Ambiente

   if !isinternet()
      MsgStop("Sem comunicao com a internet","Ateno")
      ::lConectado := .F.
   endif

RETURN( SELF )

METHOD TFPConecta() CLASS TFPOPULAR

   ::lConectado := .T.
   *---> Abertura das funcoes para WebService do xHarbour <---*
   try
      doc := GetActiveObject( "MSXML2.DOMDocument" )
   catch
      try
         doc := CreateObject( "MSXML2.DOMDocument" )
      catch
         MsgStop("Erro na criao do objeto MSXML2.DOMDocument : " + Ole2TxtError(),'Ateno')
         ::lConectado := .F.
      end
   end

   try
      http := GetActiveObject( "MSXML2.SERVERXMLHTTP.6.0" )
   catch
      try
         http := CreateObject( "MSXML2.SERVERXMLHTTP.6.0" )
      catch
         MsgStop("Erro na criao do objeto MSXML2.SERVERXMLHTTP.6.0 : " + Ole2TxtError(),'Ateno')
         ::lConectado := .F.
      end
   end
   if ::lConectado
      if ::lAmbiente
         *---> ENDERECO DE PRODUCAO <---*
         http:Open( "POST", "https://200.214.130.55:9443/farmaciapopular/services/ServicoSolicitacaoWS?wsdl HTTP/1.1", .F. )
         http:SetRequestHeader( "Content-Type"   , 'text/xml; charset="utf-8"' )
         http:SetRequestHeader( "Host"           , "200.214.130.55:9443" )
         http:SetRequestHeader( "User-Agent"     , "Borland SOAP 1.2" )
         http:SetRequestHeader( "Connection"     , "Keep-Alive" )
         http:SetRequestHeader( "Cache-Control"  , "no-cache"   )
         doc:async              := .T.
         doc:validateOnParse    := .T.
         doc:resolveExternals   := .T.
         doc:preserveWhiteSpace := .T.
      else
         *---> ENDERECO DE HOMOLOGACAO <---*
         http:Open( "POST", "https://200.214.130.41:9443/farmaciahomologa/services/ServicoSolicitacaoWS?wsdl HTTP/1.1", .F. )
         http:SetRequestHeader( "Content-Type"   , 'text/xml; charset="utf-8"' )
         http:SetRequestHeader( "Host"           , "200.214.130.41:9443" )
         http:SetRequestHeader( "User-Agent"     , "Borland SOAP 1.2" )
         http:SetRequestHeader( "Connection"     , "Keep-Alive" )
         http:SetRequestHeader( "Cache-Control"  , "no-cache"   )
         doc:async              := .T.
         doc:validateOnParse    := .T.
         doc:resolveExternals   := .T.
         doc:preserveWhiteSpace := .T.
      endif
   endif    

RETURN( .T. )

METHOD End() CLASS TFPOPULAR
   ::Close()
Return( .T. )

METHOD ZeraVariaveis() CLASS TFPOPULAR
   ::SenhaFar         := ""
   ::SenhaVen         := ""
   ::UsuarioFar       := ""
   ::UsuarioVen       := ""
   ::Data_Receita     := CTOD("  /  /    ")
   ::Cnpj             := ""
   ::nSolicitacao     := ""
   ::nAutorizacao     := ""
   ::Cpf              := ""
   ::Nome             := ""
   ::Crm              := ""
   ::UF               := ""
   ::lAmbiente        := .F.
   ::CupomFiscal      := ""
   ::Vinculado        := ""
   ::Status           := ""
   ::Mensagem         := ""
   ::aProdutos        := {}
   ::Dna              := ""
RETURN( .T. )

************************************************************************
METHOD TFPSolicitacao() CLASS TFPOPULAR
************************************************************************
   LOCAL Data_Time, nItem, aItens := {}, cXml, oXmlDoc, oXmlNode, cErrorMsg

   ::TFPConecta()

   if !::lConectado
      MsgStop('No Conectado no Farmcia Popular!','Ateno')
      Return( .F. )
   endif
   
   if empty(dtos(::data_receita))
      ::data_receita := date()
   endif
   Data_Time      := transform(dtos(::data_receita),"@R 9999-99-99")+"T"+time()
   ::nsolicitacao := dtos(date())+strtran(time(),":")
   ::Status       := ""
   ::CodRetorno   := ""
   ::Mensagem     := ""

   *---> Gerar DNA do computador <---*
   if !::TFPGeraDna()
      Return( .F. )
   endif
   if empty( ::Dna )
      MsgStop("Erro na gerao do DNA da estao",'Ateno')
      return( .F. )
   endif
   For nItem:=1 To Len(::aProdutos)
      if( ::aProdutos[nItem][01] == Nil, ::aProdutos[nItem][01] := "" , Nil ) //coCodigoBarra
      if( ::aProdutos[nItem][02] == Nil, ::aProdutos[nItem][02] := "" , Nil ) //dsUnidApresentacao
      if( ::aProdutos[nItem][03] == Nil, ::aProdutos[nItem][03] := "" , Nil ) //inAutorizacaoEstorno
      if( ::aProdutos[nItem][04] == Nil, ::aProdutos[nItem][04] := "" , Nil ) //inAutorizacaoMedicamento
      if( ::aProdutos[nItem][05] == Nil, ::aProdutos[nItem][05] := "0", Nil ) //qtAutorizada
      if( ::aProdutos[nItem][06] == Nil, ::aProdutos[nItem][06] := "0", Nil ) //qtDevolvida
      if( ::aProdutos[nItem][07] == Nil, ::aProdutos[nItem][07] := "0", Nil ) //qtEstornada
      if( ::aProdutos[nItem][08] == Nil, ::aProdutos[nItem][08] := "0", Nil ) //qtPrescrita
      if( ::aProdutos[nItem][09] == Nil, ::aProdutos[nItem][09] := "0", Nil ) //qtSolicitada
      if( ::aProdutos[nItem][10] == Nil, ::aProdutos[nItem][10] := "" , Nil ) //statusTransacao
      if( ::aProdutos[nItem][11] == Nil, ::aProdutos[nItem][11] := "0", Nil ) //vlPrecoSubsidiadoMS
      if( ::aProdutos[nItem][12] == Nil, ::aProdutos[nItem][12] := "0", Nil ) //vlPrecoSubsidiadoPaciente
      if( ::aProdutos[nItem][13] == Nil, ::aProdutos[nItem][13] := "0", Nil ) //vlPrecoSubsidiadoPacientePosEstorno
      if( ::aProdutos[nItem][14] == Nil, ::aProdutos[nItem][14] := "0", Nil ) //vlPrecoVenda
      if( ::aProdutos[nItem][15] == Nil, ::aProdutos[nItem][15] := "0", Nil ) //vlrSubsidiadoMSPosEstorno
      if( ::aProdutos[nItem][16] == Nil, ::aProdutos[nItem][16] := "0", Nil ) //vlrTotalVendaPosEstorno
   Next
   if empty( ::aProdutos[01][01] )
      MsgStop('Cdigo de Barras invlido!','Ateno')
      Return( .F. )
   endif
   cXml := ""
   cXml += '<?xml version="1.0" encoding="UTF-8" standalone="no"?>'+CRLF
   cXml += '<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:apachesoap="http://xml.apache.org/xml-soap" xmlns:impl="http://service.datasus.org/" xmlns:intf="http://service.datasus.org/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:wsdlsoap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" >'+CRLF
   cXml += '  <SOAP-ENV:Body><mns:executarSolicitacao xmlns:mns="http://service.datasus.org/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">'+CRLF
   cXml += '    <in0 xsi:type="impl:SolicitacaoDTO">'+CRLF
   cXml += '      <arrMedicamentoDTO xsi:type="soapenc:Array" soapenc:arrayType="impl:MedicamentoDTO[2]">'+CRLF
   For nItem:=1 To Len(::aProdutos)
      cXml += '        <impl:MedicamentoDTO xsi:type="impl:MedicamentoDTO">'+CRLF
      cXml += '          <coCodigoBarra xsi:type="xsd:string">'+::aProdutos[nItem][01]+'</coCodigoBarra>'+CRLF
      cXml += '          <dsUnidApresentacao xsi:type="xsd:string">'+::aProdutos[nItem][02]+'</dsUnidApresentacao>'+CRLF
      cXml += '          <inAutorizacaoEstorno xsi:type="xsd:string">'+::aProdutos[nItem][03]+'</inAutorizacaoEstorno>'+CRLF
      cXml += '          <inAutorizacaoMedicamento xsi:type="xsd:string">'+::aProdutos[nItem][04]+'</inAutorizacaoMedicamento>'+CRLF
      cXml += '          <qtAutorizada xsi:type="xsd:double">'+::aProdutos[nItem][05]+'</qtAutorizada>'+CRLF
      cXml += '          <qtDevolvida xsi:type="xsd:double">'+::aProdutos[nItem][06]+'</qtDevolvida>'+CRLF
      cXml += '          <qtEstornada xsi:type="xsd:double">'+::aProdutos[nItem][07]+'</qtEstornada>'+CRLF
      cXml += '          <qtPrescrita xsi:type="xsd:double">'+::aProdutos[nItem][08]+'</qtPrescrita>'+CRLF
      cXml += '          <qtSolicitada xsi:type="xsd:double">'+::aProdutos[nItem][09]+'</qtSolicitada>'+CRLF
      cXml += '          <statusTransacao xsi:type="xsd:string">'+::aProdutos[nItem][10]+'</statusTransacao>'+CRLF
      cXml += '          <vlPrecoSubsidiadoMS xsi:type="xsd:double">'+::aProdutos[nItem][11]+'</vlPrecoSubsidiadoMS>'+CRLF
      cXml += '          <vlPrecoSubsidiadoPaciente xsi:type="xsd:double">'+::aProdutos[nItem][12]+'</vlPrecoSubsidiadoPaciente>'+CRLF
      cXml += '          <vlPrecoSubsidiadoPacientePosEstorno xsi:type="xsd:double">'+::aProdutos[nItem][13]+'</vlPrecoSubsidiadoPacientePosEstorno>'+CRLF
      cXml += '          <vlPrecoVenda xsi:type="xsd:double">'+::aProdutos[nItem][14]+'</vlPrecoVenda>'+CRLF
      cXml += '          <vlrSubsidiadoMSPosEstorno xsi:type="xsd:double">'+::aProdutos[nItem][15]+'</vlrSubsidiadoMSPosEstorno>'+CRLF
      cXml += '          <vlrTotalVendaPosEstorno xsi:type="xsd:double">'+::aProdutos[nItem][16]+'</vlrTotalVendaPosEstorno>'+CRLF
      cXml += '        </impl:MedicamentoDTO>'+CRLF
   Next
   cXml += '      </arrMedicamentoDTO>'+CRLF
   cXml += '      <coSolicitacaoFarmacia xsi:type="xsd:string">'+::nSolicitacao+'</coSolicitacaoFarmacia>'+CRLF
   cXml += '      <dnaEstacao xsi:type="xsd:string">'+::Dna+'</dnaEstacao>'+CRLF
   cXml += '      <dtEmissaoReceita xsi:type="xsd:dateTime">'+Data_Time+'</dtEmissaoReceita>'+CRLF
   cXml += '      <nuCnpj xsi:type="xsd:string">'+::Cnpj+'</nuCnpj>'+CRLF
   cXml += '      <nuCpf xsi:type="xsd:string">'+::Cpf+'</nuCpf>'+CRLF
   cXml += '      <nuCrm xsi:type="xsd:string">'+::Crm+'</nuCrm>'+CRLF
   cXml += '      <sgUfCrm xsi:type="xsd:string">'+::UF+'</sgUfCrm>'+CRLF
   cXml += '    </in0>'+CRLF
   cXml += '    <in1 xsi:type="impl:UsuarioFarmaciaDTO">'+CRLF
   cXml += '      <senhaFarmacia xsi:type="xsd:string">'+::SenhaFar+'</senhaFarmacia>'+CRLF
   cXml += '      <senhaVendedor xsi:type="xsd:string">'+::SenhaVen+'</senhaVendedor>'+CRLF
   cXml += '      <usuarioFarmacia xsi:type="xsd:string">'+::UsuarioFar+'</usuarioFarmacia>'+CRLF
   cXml += '      <usuarioVendedor xsi:type="xsd:string">'+::UsuarioVen+'</usuarioVendedor>'+CRLF
   cXml += '    </in1>'+CRLF
   cXml += '  </mns:executarSolicitacao>'+CRLF
   cXml += '</SOAP-ENV:Body></SOAP-ENV:Envelope>'+CRLF
   
   ferase("envioSolic.txt")
   memowrit("envioSolic.txt", cXml)
   TRY
      http:SetRequestHeader( "SOAPAction" , "executarSolicitacao" )
      doc:LoadXML( cXml )                // Carrega o request de string
   CATCH
      MsgStop('Falha na criao do XML','Solicitao')
      Return( .F. )
   END
   
   if doc:parseError:errorCode # 0
      cErrorMsg := "No foi possivel carregar o documento pois ele no corresponde ao seu Schema"
      cErrorMsg := cErrorMsg + " Linha: " + str(doc:parseError:line)
      cErrorMsg := cErrorMsg + " Caractere na linha: " + str(doc:parseError:linepos)
      cErrorMsg := cErrorMsg + " Causa do erro: " + doc:parseError:reason+"code: " + str(doc:parseError:errorCode)
      MsgStop(cErrorMsg,'Ateno')
      RETURN( .F. )
   endif
   TRY
      http:SetOption( 2, 13056 )
      http:send( doc:xml )               // Envia o request
   CATCH
      MsgStop('Falha no Site do Farmcia Popular, Tente mais tarde!','Solicitao')
      Return( .F. )
   END
   
   while http:readyState <> 4
      millisec(50)
   enddo

   response  := http:responseText     // Recebe a resposta
   memowrit("retornoSolic.txt", response)

   oXmlDoc:=TXmlDocument():new()
   oXmlDoc:read( response )
   
   oXmlNode       := oXmlDoc:findFirst( "inAutorizacaoSolicitacao" )
   ::CodRetorno   := ConvHTML( oXmlNode:cData )
   oXmlNode       := oXmlDoc:findFirst( "descMensagemErro" )
   ::Mensagem     := ConvHTML( oXmlNode:cData )
   oXmlNode       := oXmlDoc:findFirst( "noPessoa" )
   ::Nome         := ConvHTML( oXmlNode:cData )
   oXmlNode       := oXmlDoc:findFirst( "nuAutorizacao" )
   ::nAutorizacao := ConvHTML( oXmlNode:cData )

   oXmlNode       := oXmlDoc:findFirst( 'coCodigoBarra' )
   ::aProdutos    := {}
   while oXmlNode != Nil
      while oXmlNode != Nil
         aadd( aItens, ConvHTML( oXmlNode:cData ) )
         oXmlNode := oXmlNode:oNext
      enddo
      aadd( ::aProdutos, aItens )
      aItens  := {}
      oXmlNode:= oXmlDoc:findNext()
   enddo 
   
RETURN( .T. )

************************************************************************
METHOD TFPConfirmacao() CLASS TFPOPULAR
************************************************************************
local cXml, oXmlDoc, oXmlNode, aItens := {}
   
   ::TFPConecta()
   
   if !::lConectado
      MsgStop('No Conectado no Farmcia Popular!','Ateno')
      Return( .F. )
   endif
   ::Status       := ""
   ::CodRetorno   := ""
   ::Mensagem     := ""

   cXml := ""
   cXml += '<?xml version="1.0" encoding="UTF-8" standalone="no"?>'+CRLF
   cXml += '<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:apachesoap="http://xml.apache.org/xml-soap" xmlns:impl="http://service.datasus.org/" xmlns:intf="http://service.datasus.org/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:wsdlsoap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" >'+CRLF
   cXml += '  <SOAP-ENV:Body><mns:confirmarAutorizacao xmlns:mns="http://service.datasus.org/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">'+CRLF
   cXml += '    <in0 xsi:type="impl:ConfirmacaoDTO">'+CRLF
   cXml += '      <coSolicitacaoFarmacia xsi:type="xsd:string">'+::nSolicitacao+'</coSolicitacaoFarmacia>'+CRLF
   cXml += '      <nuAutorizacao xsi:type="xsd:string">'+::nAutorizacao+'</nuAutorizacao>'+CRLF
   cXml += '      <nuCupomFiscal xsi:type="xsd:string">'+::CupomFiscal+'</nuCupomFiscal>'+CRLF
   cXml += '    </in0>'+CRLF
   cXml += '    <in1 xsi:type="impl:UsuarioFarmaciaDTO">'+CRLF
   cXml += '      <senhaFarmacia xsi:type="xsd:string">'+::SenhaFar+'</senhaFarmacia>'+CRLF
   cXml += '      <senhaVendedor xsi:type="xsd:string">'+::SenhaVen+'</senhaVendedor>'+CRLF
   cXml += '      <usuarioFarmacia xsi:type="xsd:string">'+::UsuarioFar+'</usuarioFarmacia>'+CRLF
   cXml += '      <usuarioVendedor xsi:type="xsd:string">'+::UsuarioVen+'</usuarioVendedor>'+CRLF
   cXml += '    </in1>'+CRLF
   cXml += '  </mns:confirmarAutorizacao>'+CRLF
   cXml += '</SOAP-ENV:Body></SOAP-ENV:Envelope>'+CRLF
   
   ferase("envioConf.txt")
   memowrit("envioConf.txt", cXml)
   
   TRY
      http:SetRequestHeader( "SOAPAction", "confirmarAutorizacao" )
      doc:LoadXML( cXml )                // Carrega o request de string
   CATCH
      MsgStop('Falha na Criao do XML!','Confirmao')
      Return( .F. )
   END
   
   if doc:parseError:errorCode # 0
      cErrorMsg := "No foi possivel carregar o documento pois ele no corresponde ao seu Schema"
      cErrorMsg := cErrorMsg + " Linha: " + str(doc:parseError:line)
      cErrorMsg := cErrorMsg + " Caractere na linha: " + str(doc:parseError:linepos)
      cErrorMsg := cErrorMsg + " Causa do erro: " + doc:parseError:reason+"code: " + str(doc:parseError:errorCode)
      MsgStop(cErrorMsg,'Ateno')
      RETURN( .F. )
   endif
   TRY
      http:SetOption( 2, 13056 )
      http:send( doc:xml )               // Envia o request
   CATCH
      MsgStop('Falha no Site do Farmcia Popular, Tente mais tarde!','Confirmao')
      Return( .F. )
   END
   
   while http:readyState <> 4
      millisec(50)
   enddo

   response  := http:responseText     // Recebe a resposta
   memowrit("retornoConf.txt", response)

   oXmlDoc:=TXmlDocument():new()
   oXMlDoc:read( response )
   
   oXmlNode       := oXmlDoc:findFirst( "nuAutorizacao" )
   ::nAutorizacao := ConvHTML( oXmlNode:cData )
   oXmlNode       := oXmlDoc:findFirst( "descMensagemErro" )
   ::Mensagem     := ConvHTML( oXmlNode:cData )
   oXmlNode       := oXmlDoc:findFirst( "statusConfirmacao" )
   ::Status       := ConvHTML( oXmlNode:cData )

   oXmlNode       := oXmlDoc:findFirst( 'coCodigoBarra' )
   ::aProdutos    := {}
   while oXmlNode != Nil
      while oXmlNode != Nil
         aadd( aItens, ConvHTML( oXmlNode:cData ) )
         oXmlNode := oXmlNode:oNext
      enddo
      aadd( ::aProdutos, aItens )
      aItens  := {}
      oXmlNode:= oXmlDoc:findNext()
   enddo 

RETURN( .T. )

************************************************************************
METHOD TFPRecebimento() CLASS TFPOPULAR
************************************************************************
LOCAL nItem, cXml, oXmlDoc, oXmlNode

   ::TFPConecta()
   
   if !::lConectado
      MsgStop('No Conectado no Farmcia Popular!','Recebimento')
      Return( .F. )
   endif
   ::Status       := ""
   ::CodRetorno   := ""
   ::Mensagem     := ""

   For nItem:=1 To Len(::aProdutos)
      if( ::aProdutos[nItem][01] == Nil, ::aProdutos[nItem][01] := "" , Nil ) //coCodigoBarra
      if( ::aProdutos[nItem][02] == Nil, ::aProdutos[nItem][02] := "" , Nil ) //dsUnidApresentacao
      if( ::aProdutos[nItem][03] == Nil, ::aProdutos[nItem][03] := "" , Nil ) //inAutorizacaoEstorno
      if( ::aProdutos[nItem][04] == Nil, ::aProdutos[nItem][04] := "" , Nil ) //inAutorizacaoMedicamento
      if( ::aProdutos[nItem][05] == Nil, ::aProdutos[nItem][05] := "0", Nil ) //qtAutorizada
      if( ::aProdutos[nItem][06] == Nil, ::aProdutos[nItem][06] := "0", Nil ) //qtDevolvida
      if( ::aProdutos[nItem][07] == Nil, ::aProdutos[nItem][07] := "0", Nil ) //qtEstornada
      if( ::aProdutos[nItem][08] == Nil, ::aProdutos[nItem][08] := "0", Nil ) //qtPrescrita
      if( ::aProdutos[nItem][09] == Nil, ::aProdutos[nItem][09] := "0", Nil ) //qtSolicitada
      if( ::aProdutos[nItem][10] == Nil, ::aProdutos[nItem][10] := "" , Nil ) //statusTransacao
      if( ::aProdutos[nItem][11] == Nil, ::aProdutos[nItem][11] := "0", Nil ) //vlPrecoSubsidiadoMS
      if( ::aProdutos[nItem][12] == Nil, ::aProdutos[nItem][12] := "0", Nil ) //vlPrecoSubsidiadoPaciente
      if( ::aProdutos[nItem][13] == Nil, ::aProdutos[nItem][13] := "0", Nil ) //vlPrecoSubsidiadoPacientePosEstorno
      if( ::aProdutos[nItem][14] == Nil, ::aProdutos[nItem][14] := "0", Nil ) //vlPrecoVenda
      if( ::aProdutos[nItem][15] == Nil, ::aProdutos[nItem][15] := "0", Nil ) //vlrSubsidiadoMSPosEstorno
      if( ::aProdutos[nItem][16] == Nil, ::aProdutos[nItem][16] := "0", Nil ) //vlrTotalVendaPosEstorno
   Next
   if empty( ::aProdutos[01][01] )
      MsgStop('Cdigo de Barras invlido!','Recebimento')
      Return( .F. )
   endif

   cXml := ""
   cXml += '<?xml version="1.0" encoding="UTF-8" standalone="no"?>'+CRLF
   cXml += '<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:apachesoap="http://xml.apache.org/xml-soap" xmlns:impl="http://service.datasus.org/" xmlns:intf="http://service.datasus.org/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:wsdlsoap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" >'+CRLF
   cXml += '  <SOAP-ENV:Body><mns:confirmarRecebimento xmlns:mns="http://service.datasus.org/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">'+CRLF
   cXml += '    <in0 xsi:type="impl:RecebimentoDTO">'+CRLF
   cXml += '      <arrMedicamentoDTO xsi:type="soapenc:Array" soapenc:arrayType="impl:MedicamentoDTO[2]">'+CRLF
   For nItem:=1 To Len(::aProdutos)
      cXml += '        <impl:MedicamentoDTO xsi:type="impl:MedicamentoDTO">'+CRLF
      cXml += '          <coCodigoBarra xsi:type="xsd:string">'+::aProdutos[nItem][01]+'</coCodigoBarra>'+CRLF
      cXml += '          <dsUnidApresentacao xsi:type="xsd:string">'+::aProdutos[nItem][02]+'</dsUnidApresentacao>'+CRLF
      cXml += '          <inAutorizacaoEstorno xsi:type="xsd:string">'+::aProdutos[nItem][03]+'</inAutorizacaoEstorno>'+CRLF
      cXml += '          <inAutorizacaoMedicamento xsi:type="xsd:string">'+::aProdutos[nItem][04]+'</inAutorizacaoMedicamento>'+CRLF
      cXml += '          <qtAutorizada xsi:type="xsd:double">'+::aProdutos[nItem][05]+'</qtAutorizada>'+CRLF
      cXml += '          <qtDevolvida xsi:type="xsd:double">'+::aProdutos[nItem][06]+'</qtDevolvida>'+CRLF
      cXml += '          <qtEstornada xsi:type="xsd:double">'+::aProdutos[nItem][07]+'</qtEstornada>'+CRLF
      cXml += '          <qtPrescrita xsi:type="xsd:double">'+::aProdutos[nItem][08]+'</qtPrescrita>'+CRLF
      cXml += '          <qtSolicitada xsi:type="xsd:double">'+::aProdutos[nItem][09]+'</qtSolicitada>'+CRLF
      cXml += '          <statusTransacao xsi:type="xsd:string">'+::aProdutos[nItem][10]+'</statusTransacao>'+CRLF
      cXml += '          <vlPrecoSubsidiadoMS xsi:type="xsd:double">'+::aProdutos[nItem][11]+'</vlPrecoSubsidiadoMS>'+CRLF
      cXml += '          <vlPrecoSubsidiadoPaciente xsi:type="xsd:double">'+::aProdutos[nItem][12]+'</vlPrecoSubsidiadoPaciente>'+CRLF
      cXml += '          <vlPrecoSubsidiadoPacientePosEstorno xsi:type="xsd:double">'+::aProdutos[nItem][13]+'</vlPrecoSubsidiadoPacientePosEstorno>'+CRLF
      cXml += '          <vlPrecoVenda xsi:type="xsd:double">'+::aProdutos[nItem][14]+'</vlPrecoVenda>'+CRLF
      cXml += '          <vlrSubsidiadoMSPosEstorno xsi:type="xsd:double">'+::aProdutos[nItem][15]+'</vlrSubsidiadoMSPosEstorno>'+CRLF
      cXml += '          <vlrTotalVendaPosEstorno xsi:type="xsd:double">'+::aProdutos[nItem][16]+'</vlrTotalVendaPosEstorno>'+CRLF
      cXml += '        </impl:MedicamentoDTO>'+CRLF
   Next
   cXml += '      </arrMedicamentoDTO>'+CRLF
   cXml += '      <nuAutorizacao xsi:type="xsd:string">'+::nAutorizacao+'</nuAutorizacao>'+CRLF
   cXml += '      <nuCupomFiscal xsi:type="xsd:string">'+::CupomFiscal+'</nuCupomFiscal>'+CRLF
   cXml += '    </in0>'+CRLF
   cXml += '    <in1 xsi:type="impl:UsuarioFarmaciaDTO">'+CRLF
   cXml += '      <senhaFarmacia xsi:type="xsd:string">'+::SenhaFar+'</senhaFarmacia>'+CRLF
   cXml += '      <senhaVendedor xsi:type="xsd:string">'+::SenhaVen+'</senhaVendedor>'+CRLF
   cXml += '      <usuarioFarmacia xsi:type="xsd:string">'+::UsuarioFar+'</usuarioFarmacia>'+CRLF
   cXml += '      <usuarioVendedor xsi:type="xsd:string">'+::UsuarioVen+'</usuarioVendedor>'+CRLF
   cXml += '    </in1>'+CRLF
   cXml += '  </mns:confirmarRecebimento>'+CRLF
   cXml += '</SOAP-ENV:Body></SOAP-ENV:Envelope>'+CRLF
   
   ferase("envioReceb.txt")
   memowrit("envioReceb.txt", cXml)
   TRY
      http:SetRequestHeader( "SOAPAction", "confirmarRecebimento" )
      doc:LoadXML( cXml )                // Carrega o request de string
   CATCH
      MsgStop('Falha na criao do XML!','Recebimento')
      Return( .F. )
   END
   
   if doc:parseError:errorCode # 0
      cErrorMsg := "No foi possivel carregar o documento pois ele no corresponde ao seu Schema"
      cErrorMsg := cErrorMsg + " Linha: " + str(doc:parseError:line)
      cErrorMsg := cErrorMsg + " Caractere na linha: " + str(doc:parseError:linepos)
      cErrorMsg := cErrorMsg + " Causa do erro: " + doc:parseError:reason+"code: " + str(doc:parseError:errorCode)
      MsgStop(cErrorMsg,'Ateno')
      RETURN NIL
   endif

   TRY
      http:SetOption( 2, 13056 )
      http:send( doc:xml )               // Envia o request
   CATCH
      MsgStop('Falha no Site do Farmcia Popular, Tente mais tarde!','Recebimento')
      Return( .F. )
   END
   
   while http:readyState <> 4
      millisec(50)
   enddo

   response  := http:responseText     // Recebe a resposta
   memowrit("retornoReceb.txt", response)

   oXmlDoc:=TXmlDocument():new()
   oXMlDoc:read( response )
   
   oXmlNode      := oXmlDoc:findFirst( "codigoRetorno" )
   ::CodRetorno  := ConvHTML( oXmlNode:cData )
   oXmlNode      := oXmlDoc:findFirst( "mensagemRetorno" )
   ::Mensagem    := ConvHTML( oXmlNode:cData )
   oXmlNode      := oXmlDoc:findFirst( "statusRecebimento" )
   ::Status      := ConvHTML( oXmlNode:cData )
   oXmlNode      := oXmlDoc:findFirst( "cupomVinculado" )
   ::Vinculado   := ConvHTML( oXmlNode:cData )

RETURN( .T. )

************************************************************************
METHOD TFPEstorno() CLASS TFPOPULAR
************************************************************************
LOCAL nItem, aItens := {}, cXml, oXmlDoc, oXmlNode

   ::TFPConecta()
   
   if !::lConectado
      MsgStop('No Conectado no Farmcia Popular!','Estorno')
      Return( .F. )
   endif
   For nItem:=1 To Len(::aProdutos)
      if( ::aProdutos[nItem][01] == Nil, ::aProdutos[nItem][01] := "" , Nil ) //coCodigoBarra
      if( ::aProdutos[nItem][02] == Nil, ::aProdutos[nItem][02] := "" , Nil ) //dsUnidApresentacao
      if( ::aProdutos[nItem][03] == Nil, ::aProdutos[nItem][03] := "" , Nil ) //inAutorizacaoEstorno
      if( ::aProdutos[nItem][04] == Nil, ::aProdutos[nItem][04] := "" , Nil ) //inAutorizacaoMedicamento
      if( ::aProdutos[nItem][05] == Nil, ::aProdutos[nItem][05] := "0", Nil ) //qtAutorizada
      if( ::aProdutos[nItem][06] == Nil, ::aProdutos[nItem][06] := "0", Nil ) //qtDevolvida
      if( ::aProdutos[nItem][07] == Nil, ::aProdutos[nItem][07] := "0", Nil ) //qtEstornada
      if( ::aProdutos[nItem][08] == Nil, ::aProdutos[nItem][08] := "0", Nil ) //qtPrescrita
      if( ::aProdutos[nItem][09] == Nil, ::aProdutos[nItem][09] := "0", Nil ) //qtSolicitada
      if( ::aProdutos[nItem][10] == Nil, ::aProdutos[nItem][10] := "" , Nil ) //statusTransacao
      if( ::aProdutos[nItem][11] == Nil, ::aProdutos[nItem][11] := "0", Nil ) //vlPrecoSubsidiadoMS
      if( ::aProdutos[nItem][12] == Nil, ::aProdutos[nItem][12] := "0", Nil ) //vlPrecoSubsidiadoPaciente
      if( ::aProdutos[nItem][13] == Nil, ::aProdutos[nItem][13] := "0", Nil ) //vlPrecoSubsidiadoPacientePosEstorno
      if( ::aProdutos[nItem][14] == Nil, ::aProdutos[nItem][14] := "0", Nil ) //vlPrecoVenda
      if( ::aProdutos[nItem][15] == Nil, ::aProdutos[nItem][15] := "0", Nil ) //vlrSubsidiadoMSPosEstorno
      if( ::aProdutos[nItem][16] == Nil, ::aProdutos[nItem][16] := "0", Nil ) //vlrTotalVendaPosEstorno
   Next
   if empty( ::aProdutos[01][01] )
      MsgStop('Cdigo de Barras invlido!','Estorno')
      Return( .F. )
   endif

   cXml := ""
   cXml += '<?xml version="1.0" encoding="UTF-8" standalone="no"?>'+CRLF
   cXml += '<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:apachesoap="http://xml.apache.org/xml-soap" xmlns:impl="http://service.datasus.org/" xmlns:intf="http://service.datasus.org/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:wsdlsoap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" >'+CRLF
   cXml += '  <SOAP-ENV:Body><mns:executarEstorno xmlns:mns="http://service.datasus.org/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">'+CRLF
   cXml += '    <in0 xsi:type="impl:EstornoDTO">'+CRLF
   cXml += '      <arrMedicamentoDTO xsi:type="soapenc:Array" soapenc:arrayType="impl:MedicamentoDTO[2]">'+CRLF
   For nItem:=1 To Len(::aProdutos)
      cXml += '        <impl:MedicamentoDTO xsi:type="impl:MedicamentoDTO">'+CRLF
      cXml += '          <coCodigoBarra xsi:type="xsd:string">'+::aProdutos[nItem][01]+'</coCodigoBarra>'+CRLF
      cXml += '          <dsUnidApresentacao xsi:type="xsd:string">'+::aProdutos[nItem][02]+'</dsUnidApresentacao>'+CRLF
      cXml += '          <inAutorizacaoEstorno xsi:type="xsd:string">'+::aProdutos[nItem][03]+'</inAutorizacaoEstorno>'+CRLF
      cXml += '          <inAutorizacaoMedicamento xsi:type="xsd:string">'+::aProdutos[nItem][04]+'</inAutorizacaoMedicamento>'+CRLF
      cXml += '          <qtAutorizada xsi:type="xsd:double">'+::aProdutos[nItem][05]+'</qtAutorizada>'+CRLF
      cXml += '          <qtDevolvida xsi:type="xsd:double">'+::aProdutos[nItem][06]+'</qtDevolvida>'+CRLF
      cXml += '          <qtEstornada xsi:type="xsd:double">'+::aProdutos[nItem][07]+'</qtEstornada>'+CRLF
      cXml += '          <qtPrescrita xsi:type="xsd:double">'+::aProdutos[nItem][08]+'</qtPrescrita>'+CRLF
      cXml += '          <qtSolicitada xsi:type="xsd:double">'+::aProdutos[nItem][09]+'</qtSolicitada>'+CRLF
      cXml += '          <statusTransacao xsi:type="xsd:string">'+::aProdutos[nItem][10]+'</statusTransacao>'+CRLF
      cXml += '          <vlPrecoSubsidiadoMS xsi:type="xsd:double">'+::aProdutos[nItem][11]+'</vlPrecoSubsidiadoMS>'+CRLF
      cXml += '          <vlPrecoSubsidiadoPaciente xsi:type="xsd:double">'+::aProdutos[nItem][12]+'</vlPrecoSubsidiadoPaciente>'+CRLF
      cXml += '          <vlPrecoSubsidiadoPacientePosEstorno xsi:type="xsd:double">'+::aProdutos[nItem][13]+'</vlPrecoSubsidiadoPacientePosEstorno>'+CRLF
      cXml += '          <vlPrecoVenda xsi:type="xsd:double">'+::aProdutos[nItem][14]+'</vlPrecoVenda>'+CRLF
      cXml += '          <vlrSubsidiadoMSPosEstorno xsi:type="xsd:double">'+::aProdutos[nItem][15]+'</vlrSubsidiadoMSPosEstorno>'+CRLF
      cXml += '          <vlrTotalVendaPosEstorno xsi:type="xsd:double">'+::aProdutos[nItem][16]+'</vlrTotalVendaPosEstorno>'+CRLF
      cXml += '        </impl:MedicamentoDTO>'+CRLF
   Next
   cXml += '      </arrMedicamentoDTO>'+CRLF
   cXml += '      <nuAutorizacao xsi:type="xsd:string">'+::nAutorizacao+'</nuAutorizacao>'+CRLF
   cXml += '      <nuCnpj xsi:type="xsd:string">'+::Cnpj+'</nuCnpj>'+CRLF
   cXml += '    </in0>'+CRLF
   cXml += '    <in1 xsi:type="impl:UsuarioFarmaciaDTO">'+CRLF
   cXml += '      <senhaFarmacia xsi:type="xsd:string">'+::SenhaFar+'</senhaFarmacia>'+CRLF
   cXml += '      <senhaVendedor xsi:type="xsd:string">'+::SenhaVen+'</senhaVendedor>'+CRLF
   cXml += '      <usuarioFarmacia xsi:type="xsd:string">'+::UsuarioFar+'</usuarioFarmacia>'+CRLF
   cXml += '      <usuarioVendedor xsi:type="xsd:string">'+::UsuarioVen+'</usuarioVendedor>'+CRLF
   cXml += '    </in1>'+CRLF
   cXml += '  </mns:executarEstorno>'+CRLF
   cXml += '</SOAP-ENV:Body></SOAP-ENV:Envelope>'+CRLF
   
   ferase("envioEst.txt")
   memowrit("envioEst.txt", cXml)
   
   TRY
      http:SetRequestHeader( "SOAPAction", "executarEstorno" )
      doc:LoadXML( cXml )                // Carrega o request de string
   CATCH
      MsgStop('Falha na criao do XML!','Estorno')
      Return( .F. )
   END
   if doc:parseError:errorCode # 0
      cErrorMsg := "No foi possivel carregar o documento pois ele no corresponde ao seu Schema"
      cErrorMsg := cErrorMsg + " Linha: " + str(doc:parseError:line)
      cErrorMsg := cErrorMsg + " Caractere na linha: " + str(doc:parseError:linepos)
      cErrorMsg := cErrorMsg + " Causa do erro: " + doc:parseError:reason+"code: " + str(doc:parseError:errorCode)
      MsgStop(cErrorMsg,'Ateno')
      RETURN(.F.)
   endif

   TRY
      http:SetOption( 2, 13056 )
      http:send( doc:xml )               // Envia o request
   CATCH
      MsgStop('Falha no Site do Farmcia Popular, Tente mais tarde!','Estorno')
      Return( .F. )
   END
   
   while http:readyState <> 4
      millisec(50)
   enddo

   response  := http:responseText     // Recebe a resposta
   memowrit("retornoEst.txt", response)

   oXmlDoc:=TXmlDocument():new()
   oXMlDoc:read( response )
   
   oXmlNode       := oXmlDoc:findFirst( "inSituacaoEstorno" )
   ::CodRetorno   := ConvHTML( oXmlNode:cData )
   oXmlNode       := oXmlDoc:findFirst( "descMensagemErro" )
   ::Mensagem     := ConvHTML( oXmlNode:cData )
   
   oXmlNode       := oXmlDoc:findFirst( 'coCodigoBarra' )
   ::aProdutos    := {}
   while oXmlNode != Nil
      while oXmlNode != Nil
         aadd( aItens, ConvHTML( oXmlNode:cData ) )
         oXmlNode := oXmlNode:oNext
      enddo
      aadd( ::aProdutos, aItens )
      aItens  := {}
      oXmlNode:= oXmlDoc:findNext()
   enddo 

RETURN( .T. )

********************************************************************************
METHOD TFPGeraDna() CLASS TFPOPULAR
********************************************************************************
   local nHandle, cTmpFile := dtos(date())+strtran(time(),":")+".dna"
   
   ::Dna := ""
   
   ferase( cTmpFile )
   if !File('gbasmsb.exe')
      MsgStop('Arquivo gbasmsb.exe no localizado!','Ateno')
      Return( .F. )
   endif
   if !WinExec( 'gbasmsb.exe --solicitacao '+::Cpf+' '+::Cnpj+' '+::Crm+' '+::UF+' '+dtoc(::Data_Receita)+' > '+ cTmpFile )
      MsgStop("Erro na gerao do DNA","Ateno")
      return( .F. )
   endif
   TRY
      nHandle := fOpen( cTmpFile )
      HB_FreadLine( nHandle, @::Dna )
      fclose( nHandle )
      ferase( cTmpFile )
   CATCH
   END
RETURN( .T. )


********************************************************************************
STATIC FUNCTION CONVHTML( cRet )
********************************************************************************
   
   Default cRet := ""
   
   if Empty( cRet )
      Return( cRet )
   endif
   
   cRet := strtran( cRet, "&#xC0;", "" )
   cRet := strtran( cRet, "&#xC1;", "" )
   cRet := strtran( cRet, "&#xC2;", "" )
   cRet := strtran( cRet, "&#xC3;", "" )
   cRet := strtran( cRet, "&#xC4;", "" )
   cRet := strtran( cRet, "&#xC5;", "" )
   cRet := strtran( cRet, "&#xC7;", "" )
   cRet := strtran( cRet, "&#xC8;", "" )
   cRet := strtran( cRet, "&#xC9;", "" )
   cRet := strtran( cRet, "&#xCA;", "" )
   cRet := strtran( cRet, "&#xCB;", "" )
   cRet := strtran( cRet, "&#xCC;", "" )
   cRet := strtran( cRet, "&#xCD;", "" )
   cRet := strtran( cRet, "&#xCE;", "" )
   cRet := strtran( cRet, "&#xCF;", "" )
   cRet := strtran( cRet, "&#xD2;", "" )
   cRet := strtran( cRet, "&#xD3;", "" )
   cRet := strtran( cRet, "&#xD4;", "" )
   cRet := strtran( cRet, "&#xD5;", "" )
   cRet := strtran( cRet, "&#xD6;", "" )
   cRet := strtran( cRet, "&#xD9;", "" )
   cRet := strtran( cRet, "&#xDA;", "" )
   cRet := strtran( cRet, "&#xDB;", "" )
   cRet := strtran( cRet, "&#xDC;", "" )
   cRet := strtran( cRet, "&#xE0;", "" )
   cRet := strtran( cRet, "&#xE1;", "" )
   cRet := strtran( cRet, "&#xE2;", "" )
   cRet := strtran( cRet, "&#xE3;", "" )
   cRet := strtran( cRet, "&#xE4;", "" )
   cRet := strtran( cRet, "&#xE5;", "" )
   cRet := strtran( cRet, "&#xE7;", "" )
   cRet := strtran( cRet, "&#xE8;", "" )
   cRet := strtran( cRet, "&#xE9;", "" )
   cRet := strtran( cRet, "&#xEA;", "" )
   cRet := strtran( cRet, "&#xEB;", "" )
   cRet := strtran( cRet, "&#xEC;", "" )
   cRet := strtran( cRet, "&#xED;", "" )
   cRet := strtran( cRet, "&#xEE;", "" )
   cRet := strtran( cRet, "&#xEF;", "" )
   cRet := strtran( cRet, "&#xF2;", "" )
   cRet := strtran( cRet, "&#xF3;", "" )
   cRet := strtran( cRet, "&#xF4;", "" )
   cRet := strtran( cRet, "&#xF5;", "" )
   cRet := strtran( cRet, "&#xF6;", "" )
   cRet := strtran( cRet, "&#xF9;", "" )
   cRet := strtran( cRet, "&#xFA;", "" )
   cRet := strtran( cRet, "&#xFB;", "" )
   cRet := strtran( cRet, "&#xFC;", "" )
RETURN( cRet )

